@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:runFlashCustom
color f9
@title %title% %version% - Flashing custom firmware [%serial_number%]
set /A failure_count=0
set /A total_failure_count=0
set oem_as_vendor=0

    call "%~dp0getPartitionTable.cmd"

    echo.
    echo. ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    if exist "%TFS_ROOT%tools\custom\custom.cmd" (
        echo.
        echo. ==^> Execute custom CMD script...
        call "%TFS_ROOT%tools\custom\custom.cmd"
        if %errorlevel% NEQ 0 (
            echo.
            echo. Device [%serial_number%] failed to execute custom script^^!
            goto :flashFailedLabel
        )
    )

    call "%~dp0doFlashCustom.cmd"

    if %errorlevel% NEQ 0 (
        echo.
        echo. Device [%serial_number%] regular partition iamges flash failed.
        goto :flashFailedLabel
    )
    set /A total_failure_count+=%failure_count%

    echo.
    echo. ==^> Clean FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear

    if "%device_has_super%" EQU "1" (
        goto :bootToFastbootd
    ) else (
        goto :endBootToFastbootd
    )

    :bootToFastbootd
        echo.
        echo. ==^> The device contains dynamic partition, will enter fastbootd mode...

        echo.
        echo. ------ Rebooting fastbootd mode ------
        %fastboot% -s %serial_number% reboot fastboot
        if %errorlevel% NEQ 0 (
            color fc
            echo.
            echo. Fatal Error: Rebooting Fastbootd mode failed^^!
            echo.
            goto :flashFailedLabel
        )

        ping -n 3 127.1 > nul 2>nul

        echo.
        echo. ------ Reconnecting [%serial_number%] ------

        %fastboot% -s %serial_number% getvar serialno > nul 2>nul
        if %errorlevel% NEQ 0 (
            color fc
            echo.
            echo. Fatal Error: Reconnecting [%serial_number%] failed^^!
            echo.
            goto :flashFailedLabel
        )

        call "%~dp0getFastbootdPT.cmd"

    :endBootToFastbootd

    for /F "usebackq tokens=*" %%C in (`%%fastboot%% -s "%%serial_number%%" getvar product 2^>^&1 ^>nul ^| %%grep%% "product:" ^| %%awk%% -F: "{print $2}" ^| %%sed%% "s@ @@g"`) do (
        set deviceName=%%C
    )

    if "%deviceName%" == "nash" ( set oem_as_vendor=1 )

    if %oem_as_vendor% == 1 (
        if exist vendor.img (
            echo.
            echo. Note: Old model detected, device name: [%deviceName%]
	    echo. OEM partition has been used as Vendor partition, renaming image names...
            %mv% -f vendor.img oem.img
        )
    )

    call "%~dp0doFlashSuper.cmd"

    set /A total_failure_count+=%failure_count%

    echo.
    REM reboot-bootloader.
    echo. ------ Rebooting to fastboot ------
    %fastboot% -s %serial_number% reboot-bootloader
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. Fatal Error: Reboot Fastboot failed^^!
        echo.
        goto :flashFailedLabel
    )

    ping -n 6 127.1 > nul 2>nul

    echo.
    echo. ------ Reconnecting [%serial_number%] ------

    %fastboot% -s %serial_number% getvar serialno > nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. Fatal Error: Reconnecting [%serial_number%] failed^^!
        echo.
        goto :flashFailedLabel
    )

    if "%finished_factory_reset%" == "1" (
        echo.
        echo. ======== Factory reset ========

        call "%~dp0doFactoryReset.cmd"
        if %errorlevel% NEQ 0 (
            echo. Device [%serial_number%] factory reset failed.
            goto :flashFailedLabel
        )
        set /A total_failure_count+=%failure_count%
    )

    if "%finished_reboot%" == "1" (
        echo.
        echo. ==^> Rebooting to system...
        %fastboot% -s %serial_number% reboot
    )

    if %total_failure_count% EQU 0 ( color f2 )
    echo.
    echo. Device [%serial_number%] all operations are complete. Total of %total_failure_count% errors.

    :flashFailedLabel
    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:tips
    echo.
    echo. Press any key to exit.
    pause > nul
::
::
:exit
exit
