@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo. Error^^! Please do not execute this file alone^^! && echo. && echo. Please press any key to exit. && pause>nul && exit

:runFullFlash
color f9
@title %title% %version% - Flashing full firmware [%serial_number%]
set /A total_failure_count=0
set factory_reset=0

    call "%~dp0getPartitionTable.cmd"

    if "%1" == "" (
        color fc
        echo.
        echo. Fatal Error: The option is empty^^!
        goto :tips
    ) else (
        set factory_reset=%1
    )
    
    if "%finished_factory_reset%" == "1" ( set factory_reset=1 )

    echo.
    echo. ==^> Setting FB mode...
    %fastboot% -s %serial_number% oem fb_mode_set

    if exist "%TFS_ROOT%tools\custom\custom.cmd" (
        echo.
        echo. ==^> Execute custom CMD script...
        call "%TFS_ROOT%tools\custom\custom.cmd"
        if %errorlevel% NEQ 0 (
            echo.
            echo. Device [%serial_number%] failed to execute custom script^^!
            goto :flashFailedLabel
        )
    )

    echo.
    echo. ======== Flashing BL ^( Bootloader Part ^) ========

    call "%~dp0doFlashBLPart.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo. Device [%serial_number%] BL ^( Bootloader Part ^) flash failed.
        goto :flashFailedLabel
    )

    echo.
    REM reboot-bootloader to apply new bootloader.
    echo. ------ Rebooting fastboot ------
    %fastboot% -s %serial_number% reboot-bootloader
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. Fatal Error: Rebooting Fastboot failed^^!
        echo.
        goto :flashFailedLabel
    )

    ping -n 6 127.1 > nul 2>nul

    echo.
    echo. ------ Reconnecting [%serial_number%] ------

    %fastboot% -s %serial_number% getvar serialno > nul 2>nul
    if %errorlevel% NEQ 0 (
        color fc
        echo.
        echo. Fatal Error: Reconnecting [%serial_number%] failed!
        echo.
        goto :flashFailedLabel
    )

    call "%~dp0getPartitionTable.cmd"

    echo.
    echo. ======== Flashing BP ^( Baseband Part ^) ========

    call "%~dp0doFlashBPart.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo. Device [%serial_number%] BP ^( Baseband Part ^) flash failed.
        goto :flashFailedLabel
    )
    set /A total_failure_count+=%failure_count%

    echo.
    echo. ======== Flashing AP ^( Android OS Part ^) ========

    call "%~dp0doFlashAPart.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo. Device [%serial_number%] AP ^( Android OS Part ^) flash failed.
        goto :flashFailedLabel
    )
    set /A total_failure_count+=%failure_count%

    if "%factory_reset%" == "1" (
        echo.
        echo. ======== Factory reset ========

        call "%~dp0doFactoryReset.cmd"
        if %errorlevel% NEQ 0 (
        echo. Device [%serial_number%] factory reset failed.
            goto :flashFailedLabel
        )
        set /A total_failure_count+=%failure_count%

        echo.
        echo. ======== Erase modem cache ========

        call "%~dp0doEraseModemst.cmd"
        set /A total_failure_count+=%failure_count%
    ) else (
        echo.
        echo. Skip factory reset...
    )

    echo.
    echo. ==^> Clean FB mode...
    %fastboot% -s %serial_number% oem fb_mode_clear

    if "%finished_reboot%" == "1" (
        echo.
        echo. ==^> Rebooting to system...
        %fastboot% -s %serial_number% reboot
    )

    if %total_failure_count% EQU 0 ( color f2 )
    echo.
    echo. Device [%serial_number%] all operations are complete. Total of %total_failure_count% errors.

    :flashFailedLabel
    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:tips
    echo.
    echo. Press any key to exit.
    pause > nul
::
::
:exit
exit
